#ifndef __PARTICLE_H__
#define __PARTICLE_H__

#include "ngl/Vector.h"
#include "ngl/Colour.h"
#include "ngl/VBOPrimitives.h"
class Particle
{
public :

	/// @brief ctor
	/// @param _pos the start position of the particle
	Particle(
						ngl::Vector _pos,
						ngl::Vector *_wind
					);
	/// @brief a method to update the particle position
	void update();
	/// @brief a method to draw the particle
	void draw();

private :
	/// @brief the curent particle position
	ngl::Vector m_pos;
	/// @brief the original particle position
	ngl::Vector m_origin;
	/// @brief the direction vector of the particle
	ngl::Vector m_dir;
	/// @brief the current life value of the particle
	float m_currentLife;
	/// @brief gravity
	GLfloat m_gravity;
	/// @brief the wind vector
	ngl::Vector *m_wind;
};


#endif
