#ifndef __EMITTER_H__
#define __EMITTER_H__
#include <vector>
#include "ngl/Vector.h"
#include "ngl/VBOPrimitives.h"

#include "Particle.h"


class Emitter
{
public :

	/// @brief ctor
	/// @param _pos the position of the emitter
	/// @param _numParticles the number of particles to create
	Emitter(
					 ngl::Vector _pos,
					 int _numParticles
				 );
	/// @brief a method to update each of the particles contained in the system
	void Update();
	/// @brief a method to draw all the particles contained in the system
	void Draw();
private :
	/// @brief the position of the emitter
	ngl::Vector m_pos;
	/// @brief the number of particles
	int m_numParticles;
	/// @brief the container for the particles
	std::vector <Particle> m_particles;

};


#endif

