#ifndef __PARTICLE_H__
#define __PARTICLE_H__

#include "ngl/Vector.h"
#include "ngl/Colour.h"
#include "ngl/VBOPrimitives.h"
class Particle
{
public :

	/// @brief ctor
	/// @param _pos the start position of the particle
	Particle(
						ngl::Vector _pos
					);
	/// @brief a method to update the particle position
	void Update();
	/// @brief a method to draw the particle
	void Draw();
	/// @brief mutator for the particle life
	inline void setLifeTime(
													 int _l
													){m_lifetime=_l;}
private :
	/// @brief the curent particle position
	ngl::Vector m_pos;
	/// @brief the original particle position
	ngl::Vector m_origin;
	/// @brief start position
	ngl::Vector m_startPos;
	/// @brief the direction vector of the particle
	ngl::Vector m_dir;
	/// @brief the current life value of the particle
	int m_currentLife;
	/// @brief the total lifetime of the current particle
	int m_lifetime;
	/// @brief colour of the particle
	ngl::Colour m_colour;
};


#endif
