#include "Particle.h"
#include "ngl/Random.h"
#include "ngl/TransformStack.h"
#include "ngl/ShaderManager.h"

/// @brief ctor
/// @param _pos the start position of the particle
Particle::Particle(ngl::Vector _pos)
{
	m_pos=_pos;
	m_origin=_pos;
  ngl::Random *rand=ngl::Random::instance();
	m_dir=rand->getRandomNormalizedVector();
	m_colour=rand->getRandomColour();
	m_lifetime=rand->randomPositiveNumber(200);
	m_currentLife=0;
}
/// @brief a method to update the particle position
void Particle::Update()
{
	m_pos+=m_dir;
	++m_currentLife;
	if(m_currentLife > m_lifetime)
	{
		m_pos=m_origin;
		m_currentLife=0;
		ngl::Random *rand=ngl::Random::instance();
		m_dir=rand->getRandomNormalizedVector();
		m_lifetime=rand->randomPositiveNumber(200);

	}
}
/// @brief a method to draw the particle
void Particle::Draw()
{
  // get the VBO instance and draw the built in teapot
  ngl::VBOPrimitives *prim=ngl::VBOPrimitives::instance();
  ngl::Transformation trans;
  ngl::ShaderManager *shader=ngl::ShaderManager::instance();
  shader->useShader("Blinn");
	ngl::TransformStack transform;
	trans.setPosition(m_pos);
	transform.setCurrent(trans);
  shader->setShaderParamFromMatrix("Blinn","ModelMatrix",transform.getCurrAndGlobal().getMatrix());
	prim->draw("sphere");

}
